// $Id: quantifiers.c,v 1.1 2017/04/04 19:40:51 leavens Exp $
#include "tap.h"
#include "quantifiers.h"

/* Requires: low <= high and p is defined for all from low to high-1
 * Ensures: result is true just when p(low), p(low+1), ..., p(high-1)
 *          are all true */
_Bool allIntsIn(predOfInt p, int low, int high) {
    _Bool res = true;
    for (int i = low; i < high; i++) {
	res = res && (*p)(i);
    }
    return res;
}

/* Requires: low <= high and p is defined for all from low to high-1
 * Ensures: result is true just when at least one of
 *          p(low), p(low+1), ..., p(high-1) is true */
_Bool someIntsIn(predOfInt p, int low, int high) {
    for (int i = low; i < high; i++) {
	if ((*p)(i)) {
	    return true;
	}
    }
    return false;
}

