// $Id: quantifiers.h,v 1.1 2017/04/04 19:40:51 leavens Exp $

#ifndef QUANTIFIERS_H
#define QUANTIFIERS_H 1
#include <stdbool.h>

typedef _Bool (*predOfInt)(int i);

/* Requires: low <= high and p is defined for all from low to high-1
 * Ensures: result is true just when p(low), p(low+1), ..., p(high-1)
 *          are all true */
extern
_Bool allIntsIn(predOfInt p, int low, int high);

/* Requires: low <= high and p is defined for all from low to high-1
 * Ensures: result is true just when at least one of
 *          p(low), p(low+1), ..., p(high-1) is true */
extern
_Bool someIntsIn(predOfInt p, int low, int high);

#endif
