// $Id: test_initarray.c,v 1.1 2017/04/05 15:01:23 leavens Exp leavens $
#include <stdbool.h>
#include "tap.h"
#include "initarray.h"
// ensures: result is true just when all the elements in a are equal to val.
static bool checkIt(const double a[], const int sz, const double val) {
    for (int i = 0; i < sz; i++) {                       // A testing helper,
	if (a[i] != val) { return false; }               // not for you to write!
    }
    return true;
}
int main() {
    double a5[5] = {0.5, 1.5, 2.5, 3.5, 4.5};
    initarray(a5, 5, 1.0);
    ok(checkIt(a5, 5, 1.0), "checkIt(a5, 5, 1.0)");
    double a10[10] = {0.01, 1.14, 2.73, 3.14, 4.44, 5.97, 6.22, 7.31, 8.99, 9.99};
    initarray(a10, 10, 3.14);
    ok(checkIt(a10, 10, 3.14), "checkIt(a10, 10, 3.14)");
    double a2000[2000];
    initarray(a2000, 2000, 2.0);
    ok(checkIt(a2000, 2000, 2.0), "checkIt(a2000, 2000, 2.0)");
    return exit_status();
}
